public class NDicePlayerGame {
    
    private final DicePlayer[] players;

    public NDicePlayerGame (int nPlayers) {
        this.players = new DicePlayer[nPlayers];
        
        for (int i = 0; i < nPlayers; i++) {
            this.players[i] = new DicePlayer("" + (i+1));
        }
    }

    public void play (Dice aDice, int objective) {
        for (int i = 0; i < this.players.length; i++) {
            this.players[i].playUntil(aDice, objective);
        }
    }

    public DicePlayer[] getWinners () {

        DicePlayer[] winners = new DicePlayer[this.players.length];
        int winnersIndex = 0;

        int minValue = this.players[0].getDiceRolls();

        for (int i = 1; i < this.players.length; i++) {
            if (this.players[i].getDiceRolls() < minValue) {
                minValue = this.players[i].getDiceRolls();
            }
        }

        // Get every player that made (minValue) rolls
        for (int i = 0; i < this.players.length; i++) {
            if (this.players[i].getDiceRolls() == minValue) {
                winners[winnersIndex] = this.players[i];
                winnersIndex++;
            }
        }

        return winners;

    }

    public static void main(String[] args) {
        
        int nPlayers = Integer.parseInt(args[0]);
        NDicePlayerGame game = new NDicePlayerGame(nPlayers);
        
        Dice dice = new Dice(6);

        game.play(dice, 20);
        
        DicePlayer[] gameWinners = game.getWinners();

        System.out.println("Les vainqueurs:");
        for (int i = 0; i < gameWinners.length; i++) {
            if (gameWinners[i] != null) {
                System.out.println(gameWinners[i]);
            }
        }

    }

}
